package com.logicbig.example;

import org.springframework.hateoas.Link;
import org.springframework.hateoas.mvc.ControllerLinkBuilder;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/employees")
public class EmployeeController {

    @GetMapping(value = "/{employeeId}")
    public Employee getEmployeeById(@PathVariable long employeeId) {
        EmployeeController theController = ControllerLinkBuilder.methodOn(EmployeeController.class);
        Employee employeeById = theController.getEmployeeById(employeeId);
        Link selfLink = ControllerLinkBuilder.linkTo(employeeById).withSelfRel();

        Employee employee = getEmployee(employeeId);
        employee.add(selfLink);
        return employee;
    }

    private Employee getEmployee(long employeeId) {
        //todo: replace with employee service
        return Employee.create(employeeId, "Lara", "Admin", 3000);
    }
}